## org.apache.mahout.math.hadoop.stochasticsvd
Class ABtDenseOutJob.QRReducer

    java.lang.Object
      org.apache.hadoop.mapreduce.Reducer<SplitPartitionedWritable,DenseBlockWritable,SplitPartitionedWritable,VectorWritable>
          org.apache.mahout.math.hadoop.stochasticsvd.ABtDenseOutJob.QRReducer

Enclosing class:
  ABtDenseOutJob

    public static class ABtDenseOutJob.QRReducer

extends org.apache.hadoop.mapreduce.Reducer<SplitPartitionedWritable,DenseBlockWritable,SplitPartitionedWritable,VectorWritable>

QR first step pushed down to reducer.

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.hadoop.mapreduce.Reducer
`org.apache.hadoop.mapreduce.Reducer.Context`

Field Summary
`protected int` `accumSize`
`protected int` `blockHeight`
`protected int` `lastTaskId`
`protected org.apache.hadoop.mapred.OutputCollector<org.apache.hadoop.io.Writable,DenseBlockWritable>` `qhatCollector`
`protected QRFirstStep` `qr`
`protected org.apache.hadoop.mapred.OutputCollector<org.apache.hadoop.io.Writable,VectorWritable>` `rhatCollector`
`protected Vector` `sb`
`protected Vector` `yiRow`

Constructor Summary
`ABtDenseOutJob.QRReducer()`

Method Summary
`protected void` `cleanup(org.apache.hadoop.mapreduce.Reducer.Context context)`
`protected void` `reduce(SplitPartitionedWritable key, Iterable<DenseBlockWritable> values, org.apache.hadoop.mapreduce.Reducer.Context context)`
`protected void` `setup(org.apache.hadoop.mapreduce.Reducer.Context context)`
`protected void` `setupBlock(org.apache.hadoop.mapreduce.Reducer.Context context, SplitPartitionedWritable spw)`

Methods inherited from class org.apache.hadoop.mapreduce.Reducer
`run`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### blockHeight

    protected int blockHeight

### accumSize

    protected int accumSize

### lastTaskId

    protected int lastTaskId

### qhatCollector

    protected org.apache.hadoop.mapred.OutputCollector<org.apache.hadoop.io.Writable,DenseBlockWritable> qhatCollector

### rhatCollector

    protected org.apache.hadoop.mapred.OutputCollector<org.apache.hadoop.io.Writable,VectorWritable> rhatCollector

### qr

    protected QRFirstStep qr

### yiRow

    protected Vector yiRow

### sb

    protected Vector sb

Constructor Detail

### ABtDenseOutJob.QRReducer

    public ABtDenseOutJob.QRReducer()

Method Detail

### setup

    protected void setup(org.apache.hadoop.mapreduce.Reducer.Context context)
                  throws IOException,
                         InterruptedException

  Overrides:
    `setup` in class `org.apache.hadoop.mapreduce.Reducer<SplitPartitionedWritable,DenseBlockWritable,SplitPartitionedWritable,VectorWritable>`
  Throws:
    `IOException`
    `InterruptedException`

### setupBlock

    protected void setupBlock(org.apache.hadoop.mapreduce.Reducer.Context context,
                              SplitPartitionedWritable spw)
                       throws InterruptedException,
                              IOException

  Throws:
    `InterruptedException`
    `IOException`

### reduce

    protected void reduce(SplitPartitionedWritable key,
                          Iterable<DenseBlockWritable> values,
                          org.apache.hadoop.mapreduce.Reducer.Context context)
                   throws IOException,
                          InterruptedException

  Overrides:
    `reduce` in class `org.apache.hadoop.mapreduce.Reducer<SplitPartitionedWritable,DenseBlockWritable,SplitPartitionedWritable,VectorWritable>`
  Throws:
    `IOException`
    `InterruptedException`

### cleanup

    protected void cleanup(org.apache.hadoop.mapreduce.Reducer.Context context)
                    throws IOException,
                           InterruptedException

  Overrides:
    `cleanup` in class `org.apache.hadoop.mapreduce.Reducer<SplitPartitionedWritable,DenseBlockWritable,SplitPartitionedWritable,VectorWritable>`
  Throws:
    `IOException`
    `InterruptedException`

Copyright © 2008–2014 The Apache Software Foundation. All rights reserved.